/* chitarra.c */

#include "descriptor/descriptor.h"

int main(void)
{
	ITEM stanza ,
	     cassa_armonica_back,
	     cassa_armonica_front,
	     base_corde, sfere , striscia , corde , manico_tot ,
	     testa_manico , regolazioni, scena ;
	ITEM attr_pareti ,
	     attr_back , attr_front , attr_base_cord , attr_sfere ,
	     attr_strisc , attr_corde , attr_manico ,attr_testa_man,
  	     attr_regolaz ;

	/* background setting */
	set_background(0.8,0.8,1,TRUE);

	/* ambient light setting */
	set_ambient_light(1,1,1,0.7);

	/*distant light creation */
	create_distant_light(0,0,1,1,1,1,0.7,"distant_light");

	/* point light creation */
	create_point_light(35.68, 5.21, 7.49, 1, 1, 1, 0.7, 0, "point_light");

	/* spot light creation */
	create_warn_light(1, 0, 0, 0, 1, 0, 1, 1, 1, 0.8, 40, 5, 70, 1, 0, 0, 1, 5, "warn_light");

	/* attribute definition */
	attr_pareti = create_attribute("pareti");
	set_color(attr_pareti,0.80, 0.7 , 0.9 ,0.72 ,0.7);
	set_reflectivity(attr_pareti,0.9 ,5);


	attr_back = create_attribute("legno_scuro_lucido");  /* laccato */
	set_color(attr_back, 0.2, 0.07, 0.07, 0.1, 0.2);
	set_reflectivity(attr_back, 0.23, 20);


	attr_front = create_attribute("legno_chiaro_lucido");
	set_color(attr_front, 0.8, 0.6, 0.5, 0.8, 0.5);
	set_reflectivity(attr_front, 0.23, 20);


	attr_base_cord = create_attribute("legno_scuro_opaco");
	set_color(attr_base_cord, 0.3, 0.15 ,0.15, 0, 0.2);
	set_reflectivity(attr_base_cord, 0, 10);


	attr_sfere  = create_attribute("nero_lucido");
        set_color(attr_sfere, 0, 0, 0, 1, 0.9);
        set_reflectivity(attr_sfere, 1, 20);


	attr_strisc  = create_attribute("bianco_opaco");
        set_color(attr_strisc, 0.9, 0.9, 0.9, 0.5, 0.5);
        set_reflectivity(attr_strisc, 0.4, 20);


	attr_manico  =  attr_back;
	attr_testa_man = attr_back;

	attr_corde  = create_attribute("corda_metallica");
        set_color(attr_corde, 0.3, 0.1, 0.1, 0.1, 0.1);
        set_reflectivity(attr_corde, 0.1, 20);


	attr_regolaz =  create_attribute("grigio_metall");
        set_color(attr_regolaz, 0.6, 0.6, 0.7, 0.2, 0.36);
        set_reflectivity(attr_regolaz, 0.5, 40);


	/* hierarchy initialization and construction */

	stanza = read_obj("piani.obj", "piani");
	set_attribute(stanza, attr_pareti);

	cassa_armonica_back = read_nurbs("base_buco.db");
	set_attribute(cassa_armonica_back, attr_back);

	cassa_armonica_front = read_nurbs("sup_forata.db");
	set_attribute(cassa_armonica_front, attr_front);


	base_corde  = read_nurbs("base_corde_sur.db");
        set_attribute(base_corde, attr_base_cord);


	sfere  = read_obj("sfere.obj", "sfere");
        set_attribute(sfere, attr_sfere);

	striscia = read_nurbs("striscia.db");
        set_attribute(striscia, attr_strisc);

	manico_tot  = read_obj("manico_tot.obj", "manico");
        set_attribute(manico_tot, attr_manico);


	testa_manico = read_nurbs("testa_manico.db");
	set_attribute(testa_manico, attr_testa_man);

	corde  = read_obj("corde.obj", "corde");
        set_attribute(corde, attr_corde);

	regolazioni  = read_obj("regolazioni.obj", "regolaz");
        set_attribute(regolazioni, attr_regolaz);


	scena = create_list(cassa_armonica_back, "scena");
	scena = insert_in_list(scena, stanza);
	scena = insert_in_list(scena, cassa_armonica_front);
	scena = insert_in_list(scena, base_corde);
	scena = insert_in_list(scena, sfere);
	scena = insert_in_list(scena, striscia);
	scena = insert_in_list(scena, corde);
	scena = insert_in_list(scena, manico_tot);
	scena = insert_in_list(scena, testa_manico);
	scena = insert_in_list(scena, regolazioni);

	save_scene("chitarra.md", "scena", scena);
	return(0);
}

